; Cubemap-Lib For Bumpmapping BSM_Renderer V1.6


Const bsm_lights=8

Global bsm_debug

Type bsm
 Field textur
 Field sphere[bsm_lights]
 Field flat[bsm_lights]
 Field pivot[bsm_lights]
 Field render[6]
 Field camera
 Field maincam
 Field dummy
 Field xpos
 Field ypos
 Field zpos
 Field updates
End Type

Type bsm_cmap
 Field cmap
 Field cmapbuf
 Field obj
 Field amblight#
 Field light[bsm_lights]
 Field art[bsm_lights]
 Field lum#[bsm_lights]
 Field dx#[bsm_lights]
 Field dy#[bsm_lights]
 Field dz#[bsm_lights]
 Field z_offset#
 Field diff#
 Field auto
End Type

Type bsm_smap
 Field smap
 Field smapbuf
 Field obj
 Field size
 Field tex[bsm_lights]
 Field light[bsm_lights]
 Field art[bsm_lights]
 Field lum#[bsm_lights]
 Field sx#[bsm_lights]
 Field sy#[bsm_lights]
 Field dx#[bsm_lights]
 Field dy#[bsm_lights]
 Field r[bsm_lights]
 Field g[bsm_lights]
 Field b[bsm_lights]
 Field diff#
 Field auto
 Field range#
End Type

Type bsm_list
 Field handl
 Field typ
 Field auto
End Type

Type bsm_coltex
 Field texture
 Field texbuffer
 Field r,g,b
 Field flag
 Field blend
End type

Function bsm_init(bsm_textur$)
 If GfxDriverCaps3D()<110 Then bsm_Error("BSM_Message: BSM_Init failed. Cubemapping not aviable")
 bsm.bsm = New bsm
 bsm\xpos=0 : bsm\ypos=1000000 : bsm\zpos=0
 bsm\textur=loadtexture(bsm_textur$,259)
 bsm\flat[0]=bsm_createflat1()
 HideEntity bsm\flat[0]
 For bsm_a=1 To bsm_lights
  bsm\pivot[bsm_a]=createpivot()
  bsm\flat[bsm_a]=copyentity(bsm\flat[0],bsm\pivot[bsm_a])
  PositionEntity bsm\flat[bsm_a],0,0,5
  EntityBlend bsm\flat[bsm_a],3
  EntityFX bsm\flat[bsm_a],1+16
  ScaleEntity bsm\flat[a],5,5,1
  PointEntity bsm\flat[bsm_a],bsm\pivot[bsm_a]
  PositionEntity bsm\pivot[bsm_a],bsm\xpos,bsm\ypos,bsm\zpos 
  HideEntity bsm\pivot[bsm_a]
 Next
 If bsm\textur>0
  PositionTexture bsm\textur,.5,0
  bsm\sphere[0]=createsphere(32) : FlipMesh bsm\sphere[0]
  EntityFX bsm\sphere[0],1
  For bsm_a=1 To bsm_lights
   bsm\sphere[bsm_a]=copyentity(bsm\sphere[0])
   ScaleEntity bsm\sphere[bsm_a],(bsm_lights+1)-bsm_a,(bsm_lights+1)-bsm_a,(bsm_lights+1)-bsm_a
 	 EntityTexture bsm\sphere[bsm_a],bsm\textur 
   HideEntity bsm\sphere[bsm_a]
   EntityOrder bsm\sphere[bsm_a],(bsm_lights+1)-bsm_a
   PositionEntity bsm\sphere[bsm_a],bsm\xpos,bsm\ypos,bsm\zpos
  Next
  EntityColor bsm\sphere[0],128,128,128
  ScaleEntity bsm\sphere[0],9,9,9
  EntityOrder bsm\sphere[0],9
  HideEntity bsm\sphere[0]
  PositionEntity bsm\sphere[0],bsm\xpos,bsm\ypos,bsm\zpos
  bsm\camera=createcamera()
  CameraViewport bsm\camera,0,0,65,65
  CameraRange bsm\camera,.1,bsm_lights+2
  HideEntity bsm\camera
  PositionEntity bsm\camera,bsm\xpos,bsm\ypos,bsm\zpos
  bsm\dummy=createpivot()
 Else
  bsm_Error("BSM_Message: Texture: "+chr$(34)+bsm_textur$+chr$(34)+" does not exist")
 EndIf
End Function

Function bsm_set_maincamera(bsm_maincam)
 bsm.bsm = First bsm
 If bsm=null Then bsm_Error("BSM_Message: BSM_Lib not initialized")
 If bsm <> Null
  If bsm_maincam>0 
   If EntityClass(bsm_maincam)="Camera"
    bsm\maincam=bsm_maincam
   Else
    bsm_Error("BSM_Message: Camera-Object not defined")
   EndIf
  EndIf
 EndIf
End Function
 
Function bsm_create_cmap(bsm_obj,bsm_on=0,bsm_layer=0)
 bsm.bsm = First bsm
 If bsm = Null Then bsm_Error("BSM_Message: BSM_Lib not initialized")
 If bsm_obj=0 Then bsm_Error("BSM_Message: Object not defined")
 If bsm_obj>0
  bsm_map.bsm_cmap= New bsm_cmap
  bsm_map\obj=bsm_obj
  bsm_map\cmap=createtexture(64,64,128+256)
  bsm_map\cmapbuf=texturebuffer(bsm_map\cmap)
  SetCubeMode bsm_map\cmap,2
  If bsm_on>0 Then EntityTexture bsm_obj,bsm_map\cmap,0,bsm_layer
  bsm_map\diff#=1
  bsm_map\auto=1
  bsm_lst.bsm_list = New bsm_list
  bsm_lst\typ=1
  bsm_lst\auto=1
  bsm_lst\handl=handle(bsm_map)
  Return bsm_map\cmap
 EndIf
End Function

Function bsm_create_smap(bsm_obj,bsm_size=256,bsm_on=0,bsm_layer=0)
 bsm.bsm = First bsm
 If bsm = Null Then bsm_Error("BSM_Message: BSM_Lib not initialized")
 If bsm_obj=0 Then bsm_Error("BSM_Message: Object not defined")
 If bsm_obj>0
  bsm_map.bsm_smap= New bsm_smap
  bsm_map\obj=bsm_obj
  bsm_map\smap=createtexture(bsm_size,bsm_size,128+256)
  bsm_map\smapbuf=texturebuffer(bsm_map\smap)
  SetCubeMode bsm_map\smap,0
  If bsm_on>0 Then EntityTexture bsm_obj,bsm_map\smap,0,bsm_layer
  bsm_map\diff#=1
  bsm_map\auto=1
  bsm_map\size=bsm_size
  bsm_lst.bsm_list = New bsm_list
  bsm_lst\typ=2
  bsm_lst\auto=1
  bsm_lst\handl=handle(bsm_map)
  Return bsm_map\smap
 EndIf
End Function

Function bsm_free_map(bsm_cmap)
 If bsm_cmap>0
 
  For bsm_map.bsm_cmap = Each bsm_cmap
   If bsm_map\cmap=bsm_cmap Then bsm_art=1 : Exit
  Next
  
  For bsm_map2.bsm_smap = Each bsm_smap
   If bsm_map2\smap=bsm_cmap Then bsm_art=2 : Exit
  Next
  
  If bsm_map<> Null And bsm_art=1
   FreeTexture bsm_map\cmap
   For bsm_lst.bsm_list = Each bsm_list
    If Handle(bsm_map) = bsm_lst\handl Then Delete bsm_lst : Exit
   Next
   Delete bsm_map
  Else
   If bsm_art=0 Then bsm_Error("BSM_Message: BSM_Map or BSM_SpecularMap does not exist")
  EndIf
  
  If bsm_map2<> Null And bsm_art=2
   FreeTexture bsm_map2\smap
   For bsm_lst.bsm_list = Each bsm_list
    If Handle(bsm_map) = bsm_lst\handl Then Delete bsm_lst : Exit
   Next
   Delete bsm_map2
  Else
   If bsm_art=0 Then bsm_Error("BSM_Message: BSM_Map or BSM_SpecularMap does not exist")
  EndIf

 EndIf
End Function

   
Function bsm_setlight(bsm_cmap,bsm_light,bsm_nr,bsm_art=2,bsm_lum#=1)
 bsm.bsm = First bsm
 If bsm = Null Then bsm_Error("BSM_Message: BSM_Lib not initialized")
 For bsm_map.bsm_cmap = Each bsm_cmap
  If bsm_map\cmap=bsm_cmap Then bsm_typ=1 : Exit
 Next
 For bsm_map2.bsm_smap = Each bsm_smap
  If bsm_map2\smap=bsm_cmap Then bsm_typ=2 : Exit
 Next
 Select bsm_typ
  Case 1
   If bsm_map<> Null
    If bsm_nr>0 And bsm_nr<=bsm_lights
     If bsm_light=0 Then bsm_Error("BSM_Message: Light-Object not defined")
     bsm_map\light[bsm_nr]=bsm_light
	   If bsm_art<1 Or bsm_art>2 Then bsm_Error("BSM_Message: invalid Type of Light")
	   bsm_map\art[bsm_nr]=bsm_art
     bsm_map\lum#[bsm_nr]=bsm_lum#
     If bsm_map\art[bsm_nr]=1
      bsm_map\dz#[bsm_nr]=entityroll#(bsm_map\obj,1)
      PositionEntity bsm\dummy,entityx#(bsm_map\obj,1),entityy#(bsm_map\obj,1),entityz#(bsm_map\obj,1)
      RotateEntity bsm\dummy,entitypitch(bsm_map\obj,1),entityyaw(bsm_map\obj,1),entityroll(bsm_map\obj,1)
      PointEntity bsm\dummy,bsm_map\light[bsm_nr]
      bsm_map\dx#[bsm_nr]=entitypitch#(bsm\dummy,1)
      bsm_map\dy#[bsm_nr]=entityyaw(bsm\dummy,1)
     Else
      bsm_map\dz#[bsm_nr]=entityroll#(bsm_map\obj,1)
      bsm_map\dx#[bsm_nr]=entitypitch#(bsm_map\light[bsm_nr],1)
      bsm_map\dy#[bsm_nr]=entityyaw(bsm_map\light[bsm_nr],1)
     EndIf
    Else
     bsm_Error("BSM_Message: Invalid Light-Number("+str$(bsm_nr)+").Must be between 1 And max. Lights. (Constant BSM_Lights="+str$(bsm_lights)+")")
    EndIf
   Else
    bsm_Error("BSM_Message: BSM_Map does Not exist")
   EndIf
  Case 2
   If bsm_map2<> Null
    If bsm_nr>0 And bsm_nr<=bsm_lights
     bsm_map2\light[bsm_nr]=bsm_light
	   If bsm_art<1 Or bsm_art>2 Then bsm_Error("BSM_Message: invalid Type of Light")
	   bsm_map2\art[bsm_nr]=bsm_art
     bsm_map2\lum#[bsm_nr]=bsm_lum#
     bsm_map2\sx#[bsm_nr]=2 : bsm_map2\sy#[bsm_nr]=2
     bsm_map2\r[bsm_nr]=255 : bsm_map2\g[bsm_nr]=255 : bsm_map2\b[bsm_nr]=255
     If bsm_map2\light[bsm_nr]>0
      If bsm_map2\art[bsm_nr]=1
       PositionEntity bsm\dummy,entityx#(bsm_map2\obj,1),entityy#(bsm_map2\obj,1),entityz#(bsm_map2\obj,1)
       PointEntity bsm\dummy,bsm_map2\light[bsm_nr]
       bsm_map2\dx#[bsm_nr]=entitypitch#(bsm\dummy,1)
       bsm_map2\dy#[bsm_nr]=entityyaw(bsm\dummy,1)
      Else
       bsm_map2\dx#[bsm_nr]=entitypitch#(bsm_map2\light[bsm_nr],1)
       bsm_map2\dy#[bsm_nr]=entityyaw(bsm_map2\light[bsm_nr],1)
      EndIf
     EndIf
     For bsm_a=1 To bsm_lights
      If bsm_map2\light[bsm_a]>0
       If bsm_map2\sx#[bsm_a]>bsm_map2\sy#[bsm_a] 
        If bsm_map2\range#<bsm_map2\sx#[bsm_a]
         bsm_map2\range#=bsm_map2\sx#[bsm_a]
        EndIf
       Else
        If bsm_map2\range#<bsm_map2\sy#[bsm_a]
         bsm_map2\range#=bsm_map2\sy#[bsm_a]
        EndIf
	     EndIf     
      EndIf
     Next
    Else
     bsm_Error("BSM_Message: Invalid Light-Number("+str$(bsm_nr)+").Must be between 1 And max. Lights. (Constant BSM_Lights="+str$(bsm_lights)+")")
    EndIf
   Else
    bsm_Error("BSM_Message: BSM_SpecularMap does Not exist")
   EndIf
  Default
   bsm_Error("BSM_Message: BSM_Map or BSM_SpecularMap does not exist")
 End Select
End Function
 
Function bsm_set_amblight(bsm_cmap,bsm_light#)
 For bsm_map.bsm_cmap = Each bsm_cmap
  If bsm_map\cmap=bsm_cmap Then Exit
 Next
 If bsm_map<> Null
  bsm_map\amblight#=bsm_light#
 Else
  bsm_Error("BSM_Message: BSM_Map does Not exist")
 EndIf
End Function

Function bsm_z_offset(bsm_cmap,bsm_angle#)
 For bsm_map.bsm_cmap = Each bsm_cmap
  If bsm_map\cmap=bsm_cmap Then Exit
 Next
 If bsm_map<> Null
  bsm_map\z_offset#=bsm_angle#
 Else
  bsm_Error("BSM_Message: BSM_Map does Not exist")
 EndIf
End Function

Function bsm_set_angle(bsm_cmap,bsm_angle#)
 For bsm_map.bsm_cmap = Each bsm_cmap
  If bsm_map\cmap=bsm_cmap Then bsm_typ=1 : Exit
 Next
 For bsm_map2.bsm_smap = Each bsm_smap
  If bsm_map2\smap=bsm_cmap Then bsm_typ=2 : Exit
 Next
 Select bsm_typ
  Case 1
   bsm_map\diff#=bsm_angle#
  Case 2
   bsm_map2\diff#=bsm_angle#
  default
   bsm_Error("BSM_Message: BSM_Map or BSM_SpecularMap does not exist")
 End select
End Function

Function bsm_set_auto(bsm_cmap,bsm_flag)
 For bsm_map.bsm_cmap = Each bsm_cmap
  If bsm_map\cmap=bsm_cmap Then bsm_typ=1 : Exit
 Next
 For bsm_map2.bsm_smap = Each bsm_smap
  If bsm_map2\smap=bsm_cmap Then bsm_typ=2 : Exit
 Next
 Select bsm_typ
  Case 1
   bsm_map\auto=bsm_flag
   For bsm_lst.bsm_list = Each bsm_list
    If Handle(bsm_map) = bsm_lst\handl Then bsm_lst\auto=bsm_flag : Exit
   Next
  Case 2
   bsm_map2\auto=bsm_flag
   For bsm_lst.bsm_list = Each bsm_list
    If Handle(bsm_map2) = bsm_lst\handl Then bsm_lst\auto=bsm_flag : Exit
   Next
  Default
   bsm_Error("BSM_Message: BSM_Map or BSM_SpecularMap does not exist")
 End select
End Function

Function bsm_set_specular_texture(bsm_smap,bsm_nr,bsm_tex)
 For bsm_map.bsm_smap = Each bsm_smap
  If bsm_map\smap=bsm_smap Then Exit
 Next
 If bsm_map<> Null
  If bsm_nr>0 And bsm_nr<=bsm_lights
   If bsm_tex>0
    bsm_map\tex[bsm_nr]=bsm_tex
   Else
    bsm_Error("BSM_Message: Texture not defined")
   EndIf
  Else
   bsm_Error("BSM_Message: Invalid Light-Number("+str$(bsm_nr)+").Must be between 1 And max. Lights. (Constant BSM_Lights="+str$(bsm_lights)+")")
  EndIf
 Else
  bsm_Error("BSM_Message: BSM_Map does not exist")
 EndIf
End Function

Function bsm_set_specular_color(bsm_smap,bsm_nr,bsm_r,bsm_g,bsm_b)
 For bsm_map.bsm_smap = Each bsm_smap
  If bsm_map\smap=bsm_smap Then Exit
 Next
 If bsm_map<> Null
  If bsm_nr>0 And bsm_nr<=bsm_lights
   bsm_map\r[bsm_nr]=bsm_r
   bsm_map\g[bsm_nr]=bsm_g
   bsm_map\b[bsm_nr]=bsm_b
  Else
   bsm_Error("BSM_Message: Invalid Light-Number("+str$(bsm_nr)+").Must be between 1 And max. Lights. (Constant BSM_Lights="+str$(bsm_lights)+")")
  EndIf
 Else
  bsm_Error("BSM_Message: BSM_Map does not exist")
 EndIf
End Function

Function bsm_set_specular_size(bsm_smap,bsm_nr,bsm_x#,bsm_y#)
 For bsm_map.bsm_smap = Each bsm_smap
  If bsm_map\smap=bsm_smap Then Exit
 Next
 If bsm_map<> Null
  If bsm_nr>0 And bsm_nr<=bsm_lights
   bsm_map\sx#[bsm_nr]=bsm_x#
   bsm_map\sy#[bsm_nr]=bsm_y#
   For bsm_a=1 To bsm_lights
    If bsm_map\light[bsm_a]>0
     If bsm_map\sx#[bsm_a]>bsm_map\sy#[bsm_a] 
      If bsm_map\range#<bsm_map\sx#[bsm_a]
       bsm_map\range#=bsm_map\sx#[bsm_a]
      EndIf
     Else
      If bsm_map\range#<bsm_map\sy#[bsm_a]
       bsm_map\range#=bsm_map\sy#[bsm_a]
      EndIf
	   EndIf     
    EndIf
   Next
  Else
   bsm_Error("BSM_Message: Invalid Light-Number("+str$(bsm_nr)+").Must be between 1 And max. Lights. (Constant BSM_Lights="+str$(bsm_lights)+")")
  EndIf
 Else
  bsm_Error("BSM_Message: BSM_Map does not exist")
 EndIf
End Function


Function BSM_set_updates(bsm_count=0)
 bsm.bsm = First bsm
 If bsm=null Then bsm_Error("BSM_Message: BSM_Lib not initialized")
 If bsm <> Null
  bsm\updates=bsm_count
 EndIf
End function

Function bsm_update(bsm_cmap,bsm_flag=0)
 bsm.bsm = First bsm
 If bsm=null Then bsm_Error("BSM_Message: BSM_Lib not initialized")
 If bsm <> Null
  For bsm_map.bsm_cmap = Each bsm_cmap
   If bsm_map\cmap=bsm_cmap Then bsm_typ=1 : Exit
  Next
  For bsm_map2.bsm_smap = Each bsm_smap
   If bsm_map2\smap=bsm_cmap Then bsm_typ=2 : Exit
  Next
  Select bsm_typ
   Case 1
    If bsm_flag=1 Then HideEntity bsm\maincam
    ShowEntity bsm\camera
    CameraViewport bsm\camera,0,0,65,65
    ShowEntity bsm\sphere[0]
    PositionEntity bsm\dummy,entityx#(bsm_map\obj,1),entityy#(bsm_map\obj,1),entityz#(bsm_map\obj,1)
    RotateEntity bsm\dummy,entitypitch(bsm_map\obj,1),entityyaw(bsm_map\obj,1),entityroll(bsm_map\obj,1)
    For bsm_a=1 To bsm_lights
     If bsm_map\light[bsm_a]>0
      If bsm_map\art[bsm_a]=2
       bsm_z#=entityroll#(bsm\dummy,1)
       PointEntity bsm\dummy,bsm_map\light[bsm_a]
       RotateEntity bsm\sphere[bsm_a],entitypitch(bsm\dummy,1),entityyaw(bsm\dummy,1),bsm_z#+bsm_map\z_offset#,1
      Else
       bsm_z#=entityroll#(bsm\dummy,1)
       RotateEntity bsm\sphere[bsm_a],entitypitch(bsm_map\light[bsm_a],1),entityyaw(bsm_map\light[bsm_a],1),bsm_z#+bsm_map\z_offset#,1
       TurnEntity bsm\sphere[bsm_a],0,180,0
      EndIf
      ShowEntity bsm\sphere[bsm_a]
      EntityAlpha bsm\sphere[bsm_a],bsm_map\lum#[bsm_a]
     EndIf
    Next
    For bsm_a=0 To 5
     Select bsm_a
      Case 0
       RotateEntity bsm\camera,0,90,0
      Case 1
       RotateEntity bsm\camera,0,0,0
      Case 2
       RotateEntity bsm\camera,0,-90,0
      Case 3
       RotateEntity bsm\camera,0,180,0
      Case 4
       RotateEntity bsm\camera,-90,0,0
      Case 5
       RotateEntity bsm\camera,90,0,0
     End Select
     SetCubeFace bsm_map\cmap,bsm_a
     RenderWorld
	   CopyRect 1,1,64,64,0,0,BackBuffer(),bsm_map\cmapbuf
	  Next
 	  For bsm_a=0 To bsm_lights
	   HideEntity bsm\sphere[bsm_a]
    Next
    HideEntity bsm\camera
    If bsm_flag=1 Then ShowEntity bsm\maincam
    
   Case 2
    If bsm_flag=1 Then HideEntity bsm\maincam
    ShowEntity bsm\camera
    CameraViewport bsm\camera,0,0,bsm_map2\size+1,bsm_map2\size+1
    PositionEntity bsm\dummy,entityx#(bsm_map2\obj,1),entityy#(bsm_map2\obj,1),entityz#(bsm_map2\obj,1)
    For bsm_a=1 To bsm_lights
     If bsm_map2\light[bsm_a]>0
      If bsm_map2\art[bsm_a]=2
       PointEntity bsm\dummy,bsm_map2\light[bsm_a]
       RotateEntity bsm\pivot[bsm_a],entitypitch(bsm\dummy,1),entityyaw(bsm\dummy,1),0,1
      Else
       RotateEntity bsm\pivot[bsm_a],entitypitch(bsm_map2\light[bsm_a],1),entityyaw(bsm_map2\light[bsm_a],1),0,1
       TurnEntity bsm\pivot[bsm_a],0,180,0
      EndIf
      ShowEntity bsm\pivot[bsm_a]
      EntityAlpha bsm\flat[bsm_a],bsm_map2\lum#[bsm_a]
      If bsm_map2\tex[bsm_a]>0 Then EntityTexture bsm\flat[bsm_a],bsm_map2\tex[bsm_a]
      EntityColor bsm\flat[bsm_a],bsm_map2\r[bsm_a],bsm_map2\g[bsm_a],bsm_map2\b[bsm_a]
      ScaleEntity bsm\flat[bsm_a],bsm_map2\sx#[bsm_a],bsm_map2\sy#[bsm_a],1
     EndIf
    Next
    For bsm_a=0 To 5
     Select bsm_a
      Case 0
       RotateEntity bsm\camera,0,90,0
      Case 1
       RotateEntity bsm\camera,0,0,0
      Case 2
       RotateEntity bsm\camera,0,-90,0
      Case 3
       RotateEntity bsm\camera,0,180,0
      Case 4
       RotateEntity bsm\camera,-90,0,0
      Case 5
       RotateEntity bsm\camera,90,0,0
     End Select
     SetCubeFace bsm_map2\smap,bsm_a
     RenderWorld
	   CopyRect 1,1,bsm_map2\size,bsm_map2\size,0,0,BackBuffer(),bsm_map2\smapbuf
	  Next
 	  For bsm_a=1 To bsm_lights
	   HideEntity bsm\pivot[bsm_a]
    Next
    HideEntity bsm\camera
    If bsm_flag=1 Then ShowEntity bsm\maincam
   Default
    bsm_Error("BSM_Message: BSM_Map or BSM_SpecularMap does Not exist")
	End select 
 endif
End Function

Function bsm_update_all(bsm_flag=0)
 bsm.bsm = First bsm
 If bsm=null Then bsm_Error("BSM_Message: BSM_Lib not initialized")
 
 If bsm <> Null
  If bsm_flag=1 Then HideEntity bsm\maincam
  
  If bsm\updates=0  
   For bsm_map.bsm_cmap = Each bsm_cmap
    If bsm_map\auto>0
     bsm_renders=bsm_renders+bsm_render_cmap(handle(bsm),handle(bsm_map))  
    EndIf       
   Next 
   For bsm_map2.bsm_smap = Each bsm_smap
    If bsm_map2\auto>0
     bsm_renders=bsm_renders+bsm_render_smap(handle(bsm),handle(bsm_map2))
    EndIf
   Next
   ;HideEntity bsm\camera

  Else
   bsm_a=0
   bsm_lst.bsm_list= First bsm_list
   bsm_test.bsm_list=bsm_lst
   Repeat
    If bsm_lst<>null
     Select bsm_lst\typ
      Case 1
       If bsm_lst\auto>0
        bsm_r=bsm_render_cmap(handle(bsm),bsm_lst\handl)
        If bsm_r=1 Then bsm_a=bsm_a+1 : bsm_renders=bsm_renders+1
       EndIf
      Case 2
       If bsm_lst\auto>0
        bsm_r=bsm_render_smap(handle(bsm),bsm_lst\handl)
        If bsm_r=1 Then bsm_a=bsm_a+1 : bsm_renders=bsm_renders+1
       endif
     End Select
     Insert bsm_lst After Last bsm_list
    Else
     Exit 
    EndIf
    bsm_lst.bsm_list= First bsm_list
   Until bsm_test.bsm_list=bsm_lst Or bsm_a=bsm\updates
  endif
  If bsm_flag=1 Then ShowEntity bsm\maincam
 EndIf
 If bsm_debug>0 Then Return bsm_renders
End function

Function bsm_end()
 bsm.bsm = First bsm
 If bsm = Null Then Return
 For bsm_a=1 To 8
  FreeEntity bsm\sphere[bsm_a]
 Next
 FreeEntity bsm\camera
 FreeEntity bsm\dummy
 FreeTexture bsm\textur
 Delete bsm
 For bsm_map.bsm_cmap = Each bsm_cmap
  FreeTexture bsm_map\cmap
  Delete bsm_map
 next
 For bsm_map2.bsm_smap = Each bsm_smap
  FreeTexture bsm_map2\smap
  Delete bsm_map2
 Next
 For bsm_lst.bsm_list = Each bsm_list
  Delete bsm_lst
 Next
End Function

Function BSM_Set_Renderpos(bsm_X,bsm_y,bsm_z)
 bsm.bsm = First bsm
 If bsm = null Then bsm_Error("BSM_Message: BSM_Lib not initialized")
 If bsm <> Null
  bsm\xpos=bsm_x
  bsm\ypos=bsm_y
  bsm\zpos=bsm_z
  For bsm_a=1 To bsm_lights
   PositionEntity bsm\sphere[bsm_a],bsm\xpos,bsm\ypos,bsm\zpos
  Next
  PositionEntity bsm\sphere[0],bsm\xpos,bsm\ypos,bsm\zpos
  PositionEntity bsm\camera,bsm\xpos,bsm\ypos,bsm\zpos
 EndIf
End function

Function BSM_Debugger(bsm_flag)
 bsm_debug=bsm_flag
End Function

Function BSM_Error(bsm_string$)
   If bsm_debug=1
    RuntimeError bsm_string$
   endif
   If bsm_debug=2
    Debuglog bsm_string$
   EndIf
   If bsm_debug=3
    Debuglog bsm_string$
    stop
   EndIf
End Function

Function BSM_make_specular(bsm_size=256,bsm_flag=1+8,bsm_mode=0,bsm_start#=0,bsm_freq#=.5,bsm_min#=0,bsm_max#=1)
 bsm_tex=createtexture(bsm_size,bsm_size,bsm_flag)
 If bsm_tex>0
  bsm_buff=texturebuffer(bsm_tex)
  bsm_tempbuff=graphicsbuffer()
  SetBuffer bsm_buff
  ClsColor 0,0,0
  Cls
  bsm_x=texturewidth(bsm_tex) : bsm_y=textureheight(bsm_tex)
  bsm_dx=bsm_x/2 : bsm_dy=bsm_y/2
  If bsm_max#<bsm_min# Then bsm_temp#=bsm_max# : bsm_max#=bsm_min# : bsm_min#=bsm_temp#
  bsm_dif#=bsm_max#-bsm_min#
  LockBuffer(bsm_buff)
  For bsm_a=0 To bsm_x-1
   For bsm_b=0 To bsm_y-1
    bsm_dist=sqr((abs(bsm_dx-bsm_a)^2)+(abs(bsm_dy-bsm_b)^2))
    If bsm_dist<=bsm_dx
     bsm_f#=1.0-(float(bsm_dist)/float(bsm_dx))
     Select bsm_mode
      Case 0
       bsm_col=(cos((.5+bsm_f#*bsm_freq#+bsm_start#)*360)*127+128)*bsm_dif#+(bsm_min#*255)
      Case 1
        bsm_w#=acos(abs(cos((.5+bsm_f#*(bsm_freq#/2.0)+(bsm_start#/2.0))*360)))
        If bsm_w#>=0 And bsm_w#<90
         bsm_col=(bsm_w#/90.0)*255*bsm_dif#+(bsm_min#*255)
        else
         bsm_col=(90.0/bsm_w#)*255*bsm_dif#+(bsm_min#*255)
				EndIf
			 Case 2
        bsm_w=sgn(cos((.5+bsm_f#*bsm_freq#+(bsm_start#/2.0))*360))
        If bsm_w>=0 
         bsm_col=255*bsm_dif#+(bsm_min#*255)
        else
         bsm_col=bsm_min#*255
				EndIf
     End select
     WritePixelFast bsm_a,bsm_b,(bsm_col Or (bsm_col Shl 8) Or (bsm_col Shl 16) Or ($ff000000))
    EndIf
   Next
  Next
  UnlockBuffer(bsm_buff)
  SetBuffer bsm_tempbuff
  Return bsm_tex
 EndIf
End Function

 
Function bsm_dot3_to_gloss(bsm_image,bsm_flag=1,bsm_new=1,bsm_txflag=1+8)
 bsm_buff = TextureBuffer ( bsm_image )
 If bsm_new=1
  bsm_x=texturewidth(bsm_image) : bsm_y=textureheight(bsm_image)
  bsm_tex=createtexture(bsm_x,bsm_y,bsm_txflag)
  bsm_buff2=texturebuffer(bsm_tex)
  CopyRect 0,0,bsm_x,bsm_y,0,0,bsm_buff,bsm_buff2
  bsm_buff=bsm_buff2
 EndIf
 bsm_cmin = 128 : bsm_cmax = 128
 LockBuffer bsm_buff
 For bsm_x = 0 To textureWidth ( bsm_image ) - 1
  For bsm_y = 0 To textureHeight( bsm_image ) - 1
   bsm_argb = ReadPixelFast ( bsm_x , bsm_y , bsm_buff )
   bsm_a = ( bsm_ARGB Shr 24 ) And $ff
   bsm_b = bsm_ARGB And $ff
   If bsm_flag = 1
    If bsm_b > bsm_cmax Then bsm_cmax = bsm_b
    If bsm_b < bsm_cmin Then bsm_cmin = bsm_b
   EndIf
   If bsm_flag = 0
    bsm_f# = bsm_b / 255.0
     bsm_g = bsm_f# * 90 + 128
     bsm_r = 218 - bsm_f# * 90
    bsm_argb = ( 218 Or ( bsm_g Shl 8 ) Or ( bsm_r Shl 16 ) Or ( $ff000000 ))
    WritePixelFast bsm_x , bsm_y , bsm_argb , bsm_buff
   EndIf
  Next
 Next
 If bsm_flag=1
  bsm_range# = bsm_cmax - bsm_cmin
  For bsm_x = 0 To textureWidth ( bsm_image ) - 1
   For bsm_y = 0 To textureHeight ( bsm_image ) - 1
    bsm_argb = ReadPixelFast ( bsm_x , bsm_y , bsm_buff )
    bsm_a = ( bsm_ARGB Shr 24 ) And $ff
    bsm_b = bsm_ARGB And $ff
    bsm_f# = ( bsm_b - bsm_cmin ) / bsm_range#
     bsm_g = bsm_f# * 90 + 128
     bsm_r = 218 - bsm_f# * 90
    bsm_argb = ( 218 Or ( bsm_g Shl 8 ) Or ( bsm_r Shl 16 ) Or ( $ff000000 ))
    WritePixelFast bsm_x , bsm_y , bsm_argb , bsm_buff
   Next
  Next
 EndIf
 UnlockBuffer bsm_buff
 Return bsm_tex
End Function

Function bsm_createflat1()
Local bsm_v[16]
bsm_obj=CreateMesh()
bsm_surf=CreateSurface(bsm_obj)
bsm_cent=AddVertex(bsm_surf,0,0,0)
VertexTexCoords bsm_surf,bsm_cent,0.5,0.5,0,0 : VertexTexCoords bsm_surf,bsm_cent,0.5,0.5,0,1
For bsm_a=0 To 15 
 bsm_x#=sin#(bsm_a*22.5) : bsm_y#=cos#(bsm_a*22.5)
 DebugLog bsm_x#+"   "+bsm_y#
 bsm_v[bsm_a]=AddVertex(bsm_surf,bsm_x#,bsm_y#,0.5)
 bsm_tx#=bsm_y#/2.0+0.5 : bsm_ty#=bsm_x#/2.0+0.5
 DebugLog bsm_tx#+"   "+bsm_ty#
 VertexTexCoords bsm_surf,bsm_v[bsm_a],bsm_tx#,bsm_ty#,0,0
 VertexTexCoords bsm_surf,bsm_v[bsm_a],bsm_tx#,bsm_ty#,0,1
Next
For bsm_a=1 To 15
 AddTriangle (bsm_surf,bsm_v[bsm_a],bsm_v[bsm_a-1],bsm_cent)
Next
 AddTriangle (bsm_surf,bsm_v[0],bsm_v[15],bsm_cent)
UpdateNormals bsm_obj
Return bsm_obj
End Function

Function bsm_render_cmap(bsm_main,bsm_mp)
 bsm.bsm = Object.bsm (bsm_main)
 bsm_map.bsm_cmap = Object.bsm_cmap (bsm_mp)
 PositionEntity bsm\dummy,entityx#(bsm_map\obj,1),entityy#(bsm_map\obj,1),entityz#(bsm_map\obj,1)
 RotateEntity bsm\dummy,entitypitch(bsm_map\obj,1),entityyaw(bsm_map\obj,1),entityroll(bsm_map\obj,1)
 bsm_render=0
 For bsm_a=1 To bsm_lights
  If bsm_map\light[bsm_a]>0    
   If bsm_map\art[bsm_a]=2
    bsm_z#=entityroll#(bsm\dummy,1)
    PointEntity bsm\dummy,bsm_map\light[bsm_a],bsm_z#
    bsm_dx#=entitypitch#(bsm\dummy,1)
    bsm_dy#=entityyaw(bsm\dummy,1)
    If Abs(bsm_dx#-bsm_map\dx#[bsm_a])>bsm_map\diff# Or Abs(bsm_dy#-bsm_map\dy#[bsm_a])>bsm_map\diff# Or Abs(bsm_z#-bsm_map\dz#[bsm_a])>bsm_map\diff#
     bsm_render=1
     bsm_map\dx#[bsm_a]=bsm_dx# : bsm_map\dy#[bsm_a]=bsm_dy# : bsm_map\dz#[bsm_a]=bsm_z#
     RotateEntity bsm\sphere[bsm_a],bsm_dx#,bsm_dy#,bsm_z#+bsm_map\z_offset#,1
    EndIf
   Else
    bsm_dx#=entitypitch#(bsm_map\light[bsm_a],1)
    bsm_dy#=entityyaw(bsm_map\light[bsm_a],1)
    bsm_z#=entityroll#(bsm\dummy,1)
    If Abs(bsm_dx#-bsm_map\dx#[bsm_a])>bsm_map\diff# Or Abs(bsm_dy#-bsm_map\dy#[bsm_a])>bsm_map\diff# Or Abs(bsm_z#-bsm_map\dz#[bsm_a])>bsm_map\diff#
     bsm_render=1
     bsm_map\dx#[bsm_a]=bsm_dx# : bsm_map\dy#[bsm_a]=bsm_dy# : bsm_map\dz#[bsm_a]=bsm_z#
     RotateEntity bsm\sphere[bsm_a],bsm_dx#,bsm_dy#,bsm_z#+bsm_map\z_offset#,1
     TurnEntity bsm\sphere[bsm_a],0,180,0
    EndIf      
   EndIf
   ShowEntity bsm\sphere[bsm_a]
   EntityAlpha bsm\sphere[bsm_a],bsm_map\lum#[bsm_a]
  endif
 Next
    
 If bsm_render=1
  ShowEntity bsm\camera
  CameraViewport bsm\camera,0,0,65,65
  CameraRange bsm\camera,.1,bsm_lights+2
  ShowEntity bsm\sphere[0]
  EntityColor bsm\sphere[0],128,128,128+(128*bsm_map\amblight#)
  For bsm_a=0 To 5
   Select bsm_a
    Case 0
     RotateEntity bsm\camera,0,90,0
    Case 1
     RotateEntity bsm\camera,0,0,0
    Case 2
     RotateEntity bsm\camera,0,-90,0
    Case 3
     RotateEntity bsm\camera,0,180,0
    Case 4
     RotateEntity bsm\camera,-90,0,0
    Case 5
     RotateEntity bsm\camera,90,0,0
   End Select
   SetCubeFace bsm_map\cmap,bsm_a
   RenderWorld
   CopyRect 1,1,64,64,0,0,BackBuffer(),bsm_map\cmapbuf
  Next
 EndIf
 
 HideEntity bsm\camera

 For bsm_a=0 To bsm_lights
  HideEntity bsm\sphere[bsm_a]
 Next  
 Return bsm_render
End Function



Function bsm_render_smap(bsm_main,bsm_mp)
 bsm.bsm = Object.bsm (bsm_main)
 bsm_map2.bsm_smap = Object.bsm_smap (bsm_mp)
 PositionEntity bsm\dummy,entityx#(bsm_map2\obj,1),entityy#(bsm_map2\obj,1),entityz#(bsm_map2\obj,1)
 bsm_render=0
 For bsm_b=0 To 5 : bsm\render[bsm_b]=0 : next
 For bsm_a=1 To bsm_lights
  If bsm_map2\light[bsm_a]>0    
   If bsm_map2\art[bsm_a]=2
    PointEntity bsm\dummy,bsm_map2\light[bsm_a]
    bsm_dx#=entitypitch#(bsm\dummy,1)
    bsm_dy#=entityyaw(bsm\dummy,1)
    If Abs(bsm_dx#-bsm_map2\dx#[bsm_a])>bsm_map2\diff# Or Abs(bsm_dy#-bsm_map2\dy#[bsm_a])>bsm_map2\diff#
     bsm_render=1
     bsm_map2\dx#[bsm_a]=bsm_dx# : bsm_map2\dy#[bsm_a]=bsm_dy#
     RotateEntity bsm\pivot[bsm_a],bsm_dx#,bsm_dy#,0,1
    EndIf
   Else
    bsm_dx#=entitypitch#(bsm_map2\light[bsm_a],1)
    bsm_dy#=entityyaw(bsm_map2\light[bsm_a],1)
    If Abs(bsm_dx#-bsm_map2\dx#[bsm_a])>bsm_map2\diff# Or Abs(bsm_dy#-bsm_map2\dy#[bsm_a])>bsm_map2\diff#
     bsm_render=1
     bsm_map2\dx#[bsm_a]=bsm_dx# : bsm_map2\dy#[bsm_a]=bsm_dy#
     RotateEntity bsm\pivot[bsm_a],bsm_dx#,bsm_dy#,0,1
     TurnEntity bsm\pivot[bsm_a],0,180,0
    EndIf      
   EndIf
   ShowEntity bsm\pivot[bsm_a]
   EntityAlpha bsm\flat[bsm_a],bsm_map2\lum#[bsm_a]
   If bsm_map2\tex[bsm_a]>0 Then EntityTexture bsm\flat[bsm_a],bsm_map2\tex[bsm_a]
   EntityColor bsm\flat[bsm_a],bsm_map2\r[bsm_a],bsm_map2\g[bsm_a],bsm_map2\b[bsm_a]
   ScaleEntity bsm\flat[bsm_a],bsm_map2\sx#[bsm_a],bsm_map2\sy#[bsm_a],(bsm_map2\sx#[bsm_a]+bsm_map2\sy#[bsm_a])/2
   ShowEntity bsm\camera
   CameraViewport bsm\camera,0,0,bsm_map2\size+1,bsm_map2\size+1
   CameraRange bsm\camera,.1,5+bsm_map2\range#
   For bsm_b=0 To 5
    Select bsm_b
     Case 0
      RotateEntity bsm\camera,0,90,0
     Case 1
      RotateEntity bsm\camera,0,0,0
     Case 2
      RotateEntity bsm\camera,0,-90,0
     Case 3
      RotateEntity bsm\camera,0,180,0
     Case 4
      RotateEntity bsm\camera,-90,0,0
     Case 5
      RotateEntity bsm\camera,90,0,0
    End Select
    If EntityInView (bsm\flat[bsm_a],bsm\camera)=1 then bsm\render[bsm_b]=1 
   Next
  EndIf
 Next
 If bsm_render=1
  CameraRange bsm\camera,.1,5+bsm_map2\range#
  For bsm_a=0 To 5
   Select bsm_a
    Case 0
     RotateEntity bsm\camera,0,90,0
    Case 1
     RotateEntity bsm\camera,0,0,0
    Case 2
     RotateEntity bsm\camera,0,-90,0
    Case 3
     RotateEntity bsm\camera,0,180,0
    Case 4
     RotateEntity bsm\camera,-90,0,0
    Case 5
     RotateEntity bsm\camera,90,0,0
   End Select
   SetCubeFace bsm_map2\smap,bsm_a
   If bsm\render[bsm_a]=1
    RenderWorld
    CopyRect 1,1,bsm_map2\size,bsm_map2\size,0,0,BackBuffer(),bsm_map2\smapbuf
   Else
	  SetBuffer bsm_map2\smapbuf
	  ClsColor 0,0,0 : Cls
	  SetBuffer BackBuffer()
	 EndIf
  Next
 EndIf
 
 HideEntity bsm\camera

 For bsm_a=1 To bsm_lights
  HideEntity bsm\pivot[bsm_a]
 Next
 Return bsm_render
End function

Function bsm_create_colortexture(bsm_r,bsm_g,bsm_b,bsm_flag=1)
 bsm_ctex.bsm_coltex = New bsm_coltex
 bsm_ctex\texture=createtexture(1,1,bsm_flag)
 bsm_ctex\texbuffer=texturebuffer(bsm_ctex\texture)
 LockBuffer bsm_ctex\texbuffer
 bsm_argb =( bsm_b Or ( bsm_g Shl 8 ) Or ( bsm_r Shl 16 ) Or ( $ff000000 ))
 WritePixelFast 0 , 0 , bsm_argb , bsm_ctex\texbuffer
 UnlockBuffer bsm_ctex\texbuffer
 bsm_ctex\r=bsm_r
 bsm_ctex\g=bsm_g
 bsm_ctex\b=bsm_b
 bsm_ctex\flag=bsm_flag
 bsm_ctex\blend=bsm_blend
 return bsm_ctex\texture
End Function

Function bsm_set_texturecolor(bsm_tex,bsm_r,bsm_g,bsm_b)
 For bsm_ctex.bsm_coltex = Each bsm_coltex
  If bsm_ctex\texture=bsm_tex
   LockBuffer bsm_ctex\texbuffer
   bsm_argb = ( bsm_b Or ( bsm_g Shl 8 ) Or ( bsm_r Shl 16 ) Or ( $ff000000 ))
   WritePixelFast 0 , 0 , bsm_argb , bsm_ctex\texbuffer
   UnlockBuffer bsm_ctex\texbuffer
   bsm_ctex\r=bsm_r
   bsm_ctex\g=bsm_g
   bsm_ctex\b=bsm_b
   Exit
  EndIf
 Next
End Function

Function bsm_free_colortexture(bsm_tex)
 For bsm_ctex.bsm_coltex = Each bsm_coltex
  If bsm_ctex\texture=bsm_tex
   FreeTexture bsm_ctex\texture
   Delete bsm_ctex
   exit
  EndIf
 Next
End Function

