;combines bumpmapping and specular-mapping with BSM
Include"bsm_lib.bb" ; including the Library
Graphics3D 800,600,0,1

bmap=loadtexture("earthbump1k.jpg") ; loading Bumpmap
TextureBlend bmap,4

colmap=loadtexture("BlueMarbleat1638.jpg") ; loading Colormap
TextureBlend colmap,2

light=createsphere() ; create Light-Dummy
EntityFX light,1
EntityColor light,255,255,100
ScaleEntity light,4,4,4

sky=createsphere() ; create Background
ScaleEntity sky,1000,1000,1000
FlipMesh sky
skytex=loadtexture("stars2.jpg")
ScaleTexture skytex,.125,.125
EntityTexture sky,skytex

cam=createcamera() 

bsm_init("norm.tga") ; initialise the BSM-Library
bsm_set_maincamera(cam)
bsm_debugger(1)
bsm_set_updates(1) ; sets max. rendered Cubemaps per frame ( saves performance)

obj=createsphere(32)  ;  create earth
RotateEntity obj,0,90,0
EntityFX obj,1

stex=bsm_make_specular()
TextureBlend stex,2
cmap=bsm_create_cmap(obj,1,0) ; generate a BSM-Cubemap and give it to the earth-object at layer 0
smap=bsm_create_smap(obj)
bsm_setlight(cmap,light,1,2,1) ; set the Light-Dummy as lightsource for the BSM-Cubemap
bsm_setlight(smap,light,1,2,1) ; set the Light-Dummy as lightsource For the BSM-Cubemap
bsm_set_specular_texture(smap,1,stex)
bsm_set_specular_color(smap,1,255,255,100)
bsm_set_specular_size(smap,1,3,3)
bsm_set_angle(cmap,1) ; set difference between actual and last angle, that forces an update
bsm_update(cmap) ; force a manual update
bsm_update(smap) ; force a manual update
bsm_set_auto(cmap,1) ; set auto-update on for this BSM-Cubemap
bsm_set_auto(smap,1) ; set auto-update on for this BSM-Cubemap
bsm_set_angle(smap,0.5)
EntityTexture obj,bmap,0,1 ;texture earth
EntityTexture obj,colmap,0,2
EntityTexture obj,smap,0,3
TextureBlend smap,3
PositionEntity cam,0,0,3

time=millisecs()
time2=millisecs()
w#=90
auto=1
tblend=1

While KeyHit(1)=0  ; mainloop

count=count+1
If MilliSecs()-time>1000 Then fps=count : count=0 : time=millisecs() ; calculate FPS
looptime#=(millisecs()-time2)/1000.0 : time2=millisecs()

TurnEntity obj,10*looptime#,10*looptime#,0

If KeyDown(203)=1 Then w#=w#+.5
If KeyDown(205)=1 Then w#=w#-.5
If KeyDown(200)=1 Then y#=y#-2*looptime#
If KeyDown(208)=1 Then y#=y#+2*looptime#

w#=w#+5*looptime#

x#=sin(w#)*13 : z#=cos(w#)*13
PositionEntity light,x#,0,z#  ; moves light around
PositionEntity cam,0,y#,2 ; moves camera up/down
PointEntity cam,obj

test=bsm_update_all(1) ; updating all active BSM-Cubemaps

UpdateWorld()
RenderWorld()
Text 10,10,"FPS "+fps
If test=1 Then Text 10,20,"Update yes" Else Text 10,20,"Update no"
Flip(0)

Wend








