;demonstrates Bumpmapping combined with normal Dx-Lightning, using a second Object-Copy
Include"bsm_lib.bb" ; including the Library
Graphics3D 800,600,0,1

bmap=loadtexture("earthbump1k.jpg") ; loading Bumpmap
TextureBlend bmap,4


colmap=loadtexture("BlueMarbleat1638.jpg") ; loading Colormap
TextureBlend colmap,2

AmbientLight 10,10,10
light=createsphere() ; create Light-Dummy
EntityFX light,1
dxlight=createlight(2,light)
LightColor dxlight,200,200,200
LightRange dxlight,130

light2=createsphere() ; create Light-Dummy2
EntityFX light2,1
EntityColor light2,255,0,0
dxlight2=createlight(2,light2)
LightColor dxlight2,200,0,0
LightRange dxlight2,50

sky=createsphere() ; create Background
ScaleEntity sky,1000,1000,1000
FlipMesh sky : EntityFX sky,1
skytex=loadtexture("stars2.jpg")
ScaleTexture skytex,.125,.125
EntityTexture sky,skytex

cam=createcamera() 
CameraRange cam,0.1,10000
bsm_debugger(1) ;BSM Error output to DebugLog

bsm_init("norm.tga") ; initialise the BSM-Library
bsm_set_maincamera(cam)
bsm_set_updates(1) ; sets max. rendered Cubemaps per frame ( saves performance)

pivot=createpivot() ;dummy-point to join the two earth-objects

obj2=createsphere(32,pivot)  ;  create normal earth-object
RotateEntity obj2,0,90,0
ScaleEntity obj2,10,10,10

obj=createsphere(32,pivot)  ;  create bumpmapped earth-object
RotateEntity obj,0,90,0
EntityFX obj,1
ScaleEntity obj,10,10,10


cmap=bsm_create_cmap(obj,1,0) ; generate a BSM-Cubemap and give it to the earth-object at layer 0
TextureBlend cmap,1 ; let the cubemap not blend with any layer beneath it
bsm_setlight(cmap,dxlight,1,2,1) ; set the Light-Dummy as lightsource For the BSM-Cubemap
bsm_setlight(cmap,dxlight2,2,2,.35) ; set the Light-Dummy2 as lightsource for the BSM-Cubemap
bsm_set_angle(cmap,1) ; set difference between actual and last angle, that forces an update
bsm_update(cmap) ; force a manual update
bsm_set_auto(cmap,1) ; set auto-update on for this BSM-Cubemap

EntityTexture obj2,colmap ; texture normal earth-object with the earth texture

EntityTexture obj,bmap,0,1 ;bumpmapped earth-object with the bump texture
EntityTexture obj,colmap,0,2 ;bumpmapped earth-object with the earth texture
EntityAlpha obj,0.99 ; set alpha less than 1 activates alphablending with bumpmaps

PositionEntity cam,0,0,3

time=millisecs()
time2=millisecs()
w#=90
auto=1
tblend=1

While KeyHit(1)=0  ; mainloop

count=count+1
If MilliSecs()-time>1000 Then fps=count : count=0 : time=millisecs() ; calculate FPS
looptime#=(millisecs()-time2)/1000.0 : time2=millisecs()

TurnEntity pivot,10*looptime#,10*looptime#,0

If KeyDown(203)=1 Then w#=w#+.5
If KeyDown(205)=1 Then w#=w#-.5
If KeyDown(200)=1 Then y#=y#-20*looptime#
If KeyDown(208)=1 Then y#=y#+20*looptime#

w#=w#+5*looptime#

If KeyHit(57)=1 Then tblend=1-tblend : TextureBlend colmap,1+tblend ; switches bumpmapping on/off
If KeyHit(28)=1 Then auto=1-auto : bsm_set_auto(cmap,auto) ; switches auto-update on/off

x#=sin(w#)*130 : z#=cos(w#)*130
PositionEntity light,x#,0,z#  ; moves light around
x#=sin(w#*5)*100 : z#=cos(w#*5)*100
PositionEntity light2,x#,x#/2,z#  ; moves light around


PositionEntity cam,0,y#,20 ; moves camera up/down
PointEntity cam,obj

test=bsm_update_all(1) ; updating all active BSM-Cubemaps


UpdateWorld()
RenderWorld()
Text 10,10,"FPS "+fps
If test=1 Then Text 10,20,"Update yes" Else Text 10,20,"Update no"
Flip(0)

Wend








